# React面试题
> 鼓励PR，持续更新（React v16.6.0）

## 历史题目(最新：2019.07.18)
[React](#React) | [ReactNative](#ReactNative) | [React-Router](#React-Router) | [Redux/Mobx](#Redux/Mobx) | [Flux](#Flux)

### React
- [什么时候使用状态管理器？](https://github.com/haizlin/fe-interview/issues/953)
- [render函数中return如果没有使用()会有什么问题？](https://github.com/haizlin/fe-interview/issues/952)
- [componentWillUpdate可以直接修改state的值吗？](https://github.com/haizlin/fe-interview/issues/951)
- [说说你对React的渲染原理的理解](https://github.com/haizlin/fe-interview/issues/950)
- [什么渲染劫持？](https://github.com/haizlin/fe-interview/issues/949)
- [React Intl是什么原理？](https://github.com/haizlin/fe-interview/issues/948)
- [你有使用过React Intl吗？](https://github.com/haizlin/fe-interview/issues/947)
- [怎么实现React组件的国际化呢？](https://github.com/haizlin/fe-interview/issues/946)
- [说说Context有哪些属性？](https://github.com/haizlin/fe-interview/issues/945)
- [怎么使用Context开发组件？](https://github.com/haizlin/fe-interview/issues/944)
- [为什么React并不推荐我们优先考虑使用Context？](https://github.com/haizlin/fe-interview/issues/943)
- [除了实例的属性可以获取Context外哪些地方还能直接获取Context呢？](https://github.com/haizlin/fe-interview/issues/942)
- [childContextTypes是什么？它有什么用？](https://github.com/haizlin/fe-interview/issues/941)
- [contextType是什么？它有什么用？](https://github.com/haizlin/fe-interview/issues/940)
- [Consumer向上找不到Provider的时候怎么办？](https://github.com/haizlin/fe-interview/issues/939)
- [有使用过Consumer吗？](https://github.com/haizlin/fe-interview/issues/938)
- [在React怎么使用Context？](https://github.com/haizlin/fe-interview/issues/937)
- [React15和16别支持IE几以上？](https://github.com/haizlin/fe-interview/issues/936)
- [说说你对windowing的了解](https://github.com/haizlin/fe-interview/issues/935)
- [举例说明React的插槽有哪些运用场景？](https://github.com/haizlin/fe-interview/issues/934)
- [你有用过React的插槽(Portals)吗？怎么用？](https://github.com/haizlin/fe-interview/issues/933)
- [React的严格模式有什么用处？](https://github.com/haizlin/fe-interview/issues/932)
- [React如何进行代码拆分？拆分的原则是什么？](https://github.com/haizlin/fe-interview/issues/931)
- [React组件的构造函数有什么作用？](https://github.com/haizlin/fe-interview/issues/930)
- [React组件的构造函数是必须的吗？](https://github.com/haizlin/fe-interview/issues/929)
- [React中在哪捕获错误？](https://github.com/haizlin/fe-interview/issues/928)
- [React怎样引入svg的文件？](https://github.com/haizlin/fe-interview/issues/927)
- [说说你对Relay的理解](https://github.com/haizlin/fe-interview/issues/926)
- [在React中你有经常使用常量吗？](https://github.com/haizlin/fe-interview/issues/925)
- [为什么说React中的props是只读的？](https://github.com/haizlin/fe-interview/issues/924)
- [你有使用过formik库吗？说说它的优缺点](https://github.com/haizlin/fe-interview/issues/923)
- [你有用过哪些React的表单库吗？说说它们的优缺点](https://github.com/haizlin/fe-interview/issues/901)
- [如果组件的属性没有传值，那么它的默认值是什么？](https://github.com/haizlin/fe-interview/issues/900)
- [可以使用TypeScript写React应用吗？怎么操作？](https://github.com/haizlin/fe-interview/issues/899)
- [`super()`和`super(props)`有什么区别？](https://github.com/haizlin/fe-interview/issues/898)
- [你有使用过loadable组件吗？它帮我们解决了什么问题？](https://github.com/haizlin/fe-interview/issues/897)
- [你有使用过suspense组件吗？它帮我们解决了什么问题？](https://github.com/haizlin/fe-interview/issues/896)
- [怎样动态导入组件？](https://github.com/haizlin/fe-interview/issues/895)
- [如何给非控组件设置默认的值？](https://github.com/haizlin/fe-interview/issues/894)
- [怎么在React中引入其它的UI库，例如Bootstrap](https://github.com/haizlin/fe-interview/issues/893)
- [怎样将事件传递给子组件？](https://github.com/haizlin/fe-interview/issues/892)
- [怎样使用Hooks获取服务端数据？](https://github.com/haizlin/fe-interview/issues/891)
- [使用Hooks要遵守哪些原则？](https://github.com/haizlin/fe-interview/issues/890)
- [render方法的原理你有了解吗？它返回的数据类型是什么？](https://github.com/haizlin/fe-interview/issues/889)
- [useEffect和useLayoutEffect有什么区别？](https://github.com/haizlin/fe-interview/issues/888)
- [在React项目中你用过哪些动画的包？](https://github.com/haizlin/fe-interview/issues/887)
- [React必须使用JSX吗？](https://github.com/haizlin/fe-interview/issues/886)
- [自定义组件时render是可选的吗？为什么？](https://github.com/haizlin/fe-interview/issues/885)
- [需要把keys设置为全局唯一吗？](https://github.com/haizlin/fe-interview/issues/884)
- [怎么定时更新一个组件？](https://github.com/haizlin/fe-interview/issues/883)
- [React根据不同的环境打包不同的域名？](https://github.com/haizlin/fe-interview/issues/882)
- [使用webpack打包React项目，怎么减小生成的js大小？](https://github.com/haizlin/fe-interview/issues/881)
- [在React中怎么使用async/await？](https://github.com/haizlin/fe-interview/issues/880)
- [你阅读了几遍React的源码？都有哪些收获？你是怎么阅读的？](https://github.com/haizlin/fe-interview/issues/879)
- [什么是React.forwardRef？它有什么作用？](https://github.com/haizlin/fe-interview/issues/878)
- [写个例子说明什么是JSX的内联条件渲染](https://github.com/haizlin/fe-interview/issues/877)
- [在React中怎么将参数传递给事件？](https://github.com/haizlin/fe-interview/issues/876)
- [React的事件和普通的HTML事件有什么不同？](https://github.com/haizlin/fe-interview/issues/875)
- [在React中怎么阻止事件的默认行为？](https://github.com/haizlin/fe-interview/issues/874)
- [你最喜欢React的哪一个特性（说一个就好）？](https://github.com/haizlin/fe-interview/issues/873)
- [在React中什么时候使用箭头函数更方便呢？](https://github.com/haizlin/fe-interview/issues/872)
- [你最不喜欢React的哪一个特性（说一个就好）？](https://github.com/haizlin/fe-interview/issues/871)
- [说说你对React的reconciliation（一致化算法）的理解](https://github.com/haizlin/fe-interview/issues/870)
- [使用PropTypes和Flow有什么区别？](https://github.com/haizlin/fe-interview/issues/869)
- [怎样有条件地渲染组件？](https://github.com/haizlin/fe-interview/issues/868)
- [在JSX中如何写注释？](https://github.com/haizlin/fe-interview/issues/867)
- [constructor和getInitialState有不同？](https://github.com/haizlin/fe-interview/issues/866)
- [写例子说明React如何在JSX中实现for循环](https://github.com/haizlin/fe-interview/issues/865)
- [为什么建议Fragment包裹元素？它的简写是什么？](https://github.com/haizlin/fe-interview/issues/864)
- [你有用过React.Fragment吗？说说它有什么用途？](https://github.com/haizlin/fe-interview/issues/863)
- [在React中你有遇到过安全问题吗？怎么解决？](https://github.com/haizlin/fe-interview/issues/862)
- [React中如何监听state的变化？](https://github.com/haizlin/fe-interview/issues/861)
- [React什么是有状态组件？](https://github.com/haizlin/fe-interview/issues/860)
- [React v15中怎么处理错误边界？](https://github.com/haizlin/fe-interview/issues/859)
- [React Fiber它的目的是解决什么问题？](https://github.com/haizlin/fe-interview/issues/858)
- [React为什么不要直接修改state？如果想修改怎么做？](https://github.com/haizlin/fe-interview/issues/857)
- [create-react-app有什么好处？](https://github.com/haizlin/fe-interview/issues/856)
- [装饰器(Decorator)在React中有什么应用？](https://github.com/haizlin/fe-interview/issues/855)
- [使用高阶组件(HOC)实现一个loading组件](https://github.com/haizlin/fe-interview/issues/854)
- [如何用React实现滚动动画？](https://github.com/haizlin/fe-interview/issues/853)
- [说出几点你认为的React最佳实践](https://github.com/haizlin/fe-interview/issues/852)
- [你是如何划分React组件的？](https://github.com/haizlin/fe-interview/issues/851)
- [举例说明如何在React创建一个事件](https://github.com/haizlin/fe-interview/issues/850)
- [如何更新组件的状态？](https://github.com/haizlin/fe-interview/issues/849)
- [怎样将多个组件嵌入到一个组件中？](https://github.com/haizlin/fe-interview/issues/848)
- [React的render中可以写{if else}这样的判断吗？](https://github.com/haizlin/fe-interview/issues/847)
- [React为什么要搞一个Hooks？](https://github.com/haizlin/fe-interview/issues/846)
- [React Hooks帮我们解决了哪些问题？](https://github.com/haizlin/fe-interview/issues/845)
- [使用React的memo和forwardRef包装的组件为什么提示children类型不对？](https://github.com/haizlin/fe-interview/issues/844)
- [有在项目中使用过Antd吗？说说它的好处](https://github.com/haizlin/fe-interview/issues/843)
- [在React中如果去除生产环境上的sourcemap？](https://github.com/haizlin/fe-interview/issues/842)
- [在React中怎么引用sass或less？](https://github.com/haizlin/fe-interview/issues/841)
- [组件卸载前，加在DOM元素的监听事件和定时器要不要手动清除？为什么？](https://github.com/haizlin/fe-interview/issues/840)
- [为什么标签里的for要写成htmlFor呢？](https://github.com/haizlin/fe-interview/issues/839)
- [状态管理器解决了什么问题？什么时候用状态管理器？](https://github.com/haizlin/fe-interview/issues/838)
- [状态管理器它精髓是什么？](https://github.com/haizlin/fe-interview/issues/837)
- [函数式组件有没有生命周期？为什么？](https://github.com/haizlin/fe-interview/issues/836)
- [在React中怎么引用第三方插件？比如说jQuery等](https://github.com/haizlin/fe-interview/issues/835)
- [React的触摸事件有哪几种？](https://github.com/haizlin/fe-interview/issues/834)
- [路由切换时同一组件无法重新渲染的有什么方法可以解决？](https://github.com/haizlin/fe-interview/issues/833)
- [React16新特性有哪些？](https://github.com/haizlin/fe-interview/issues/832)
- [你有用过哪些React的UI库？它们的优缺点分别是什么？](https://github.com/haizlin/fe-interview/issues/831)
- [`<div onClick={handlerClick}>单击</div>`和`<div onClick={handlerClick(1)}>单击</div>`有什么区别？](https://github.com/haizlin/fe-interview/issues/830)
- [在React中如何引入图片？哪种方式更好？](https://github.com/haizlin/fe-interview/issues/829)
- [在React中怎么使用字体图标？](https://github.com/haizlin/fe-interview/issues/828)
- [React的应用如何打包发布？它的步骤是什么？](https://github.com/haizlin/fe-interview/issues/827)
- [ES6的语法'...'在React中有哪些应用？](https://github.com/haizlin/fe-interview/issues/826)
- [如何封装一个React的全局公共组件？](https://github.com/haizlin/fe-interview/issues/825)
- [在React中组件的props改变时更新组件的有哪些方法？](https://github.com/haizlin/fe-interview/issues/824)
- [immutable的原理是什么？](https://github.com/haizlin/fe-interview/issues/823)
- [你对immutable有了解吗？它有什么作用？](https://github.com/haizlin/fe-interview/issues/822)
- [如何提高组件的渲染效率呢？](https://github.com/haizlin/fe-interview/issues/821)
- [在React中如何避免不必要的render？](https://github.com/haizlin/fe-interview/issues/820)
- [render在什么时候会被触发？](https://github.com/haizlin/fe-interview/issues/819)
- [写出React动态改变class切换组件样式](https://github.com/haizlin/fe-interview/issues/818)
- [React中怎么操作虚拟DOM的Class属性？](https://github.com/haizlin/fe-interview/issues/817)
- [为什么属性使用className而不是class呢？](https://github.com/haizlin/fe-interview/issues/816)
- [请说下react组件更新的机制是什么？](https://github.com/haizlin/fe-interview/issues/815)
- [怎么在JSX里属性可以被覆盖吗？覆盖的原则是什么？](https://github.com/haizlin/fe-interview/issues/814)
- [怎么在JSX里使用自定义属性？](https://github.com/haizlin/fe-interview/issues/813)
- [怎么防止HTML被转义？](https://github.com/haizlin/fe-interview/issues/812)
- [经常用React，你知道React的核心思想是什么吗？](https://github.com/haizlin/fe-interview/issues/811)
- [在React中我们怎么做静态类型检测？都有哪些方法可以做到？](https://github.com/haizlin/fe-interview/issues/810)
- [在React中组件的state和setState有什么区别？](https://github.com/haizlin/fe-interview/issues/809)
- [React怎样跳过重新渲染？](https://github.com/haizlin/fe-interview/issues/808)
- [React怎么判断什么时候重新渲染组件呢？](https://github.com/haizlin/fe-interview/issues/807)
- [什么是React的实例？函数式组件有没有实例？](https://github.com/haizlin/fe-interview/issues/806)
- [在React中如何判断点击元素属于哪一个组件？](https://github.com/haizlin/fe-interview/issues/805)
- [在React中组件和元素有什么区别？](https://github.com/haizlin/fe-interview/issues/804)
- [在React中声明组件时组件名的第一个字母必须是大写吗？为什么？](https://github.com/haizlin/fe-interview/issues/803)
- [举例说明什么是高阶组件(HOC)的反向继承？](https://github.com/haizlin/fe-interview/issues/802)
- [有用过React Devtools吗？说说它的优缺点分别是什么？](https://github.com/haizlin/fe-interview/issues/801)
- [举例说明什么是高阶组件(HOC)的属性代理？](https://github.com/haizlin/fe-interview/issues/800)
- [React的isMounted有什么作用？](https://github.com/haizlin/fe-interview/issues/799)
- [React组件命名推荐的方式是哪个？为什么不推荐使用displayName？](https://github.com/haizlin/fe-interview/issues/798)
- [React的displayName有什么作用？](https://github.com/haizlin/fe-interview/issues/797)
- [说说你对React的组件命名规范的理解](https://github.com/haizlin/fe-interview/issues/796)
- [说说你对React的项目结构的理解](https://github.com/haizlin/fe-interview/issues/795)
- [React16废弃了哪些生命周期？为什么？](https://github.com/haizlin/fe-interview/issues/794)
- [怎样在React中开启生产模式？](https://github.com/haizlin/fe-interview/issues/793)
- [React中getInitialState方法的作用是什么？](https://github.com/haizlin/fe-interview/issues/792)
- [React中你知道creatClass的原理吗？](https://github.com/haizlin/fe-interview/issues/791)
- [React中验证props的目的是什么？](https://github.com/haizlin/fe-interview/issues/790)
- [React中你有使用过getDefaultProps吗？它有什么作用？](https://github.com/haizlin/fe-interview/issues/789)
- [React中你有使用过propType吗？它有什么作用？](https://github.com/haizlin/fe-interview/issues/788)
- [React中怎么检验props？](https://github.com/haizlin/fe-interview/issues/787)
- [React.createClass和extends Component的区别有哪些？](https://github.com/haizlin/fe-interview/issues/786)
- [高阶组件(HOC)有哪些优点和缺点？](https://github.com/haizlin/fe-interview/issues/785)
- [给组件设置很多属性时不想一个个去设置有什么办法可以解决这问题呢？](https://github.com/haizlin/fe-interview/issues/784)
- [React16跟之前的版本生命周期有哪些变化？](https://github.com/haizlin/fe-interview/issues/756)
- [怎样实现React组件的记忆？原理是什么？](https://github.com/haizlin/fe-interview/issues/755)
- [创建React动画有哪些方式？](https://github.com/haizlin/fe-interview/issues/754)
- [为什么建议不要过渡使用Refs？](https://github.com/haizlin/fe-interview/issues/753)
- [在React使用高阶组件(HOC)有遇到过哪些问题？如何解决？](https://github.com/haizlin/fe-interview/issues/752)
- [在使用React过程中什么时候用高阶组件(HOC)？](https://github.com/haizlin/fe-interview/issues/751)
- [说说React diff的原理是什么？](https://github.com/haizlin/fe-interview/issues/724)
- [React怎么提高列表渲染的性能？](https://github.com/haizlin/fe-interview/issues/723)
- [使用ES6的class定义的组件不支持mixins了，那用什么可以替代呢？](https://github.com/haizlin/fe-interview/issues/722)
- [为何说虚拟DOM会提高性能？](https://github.com/haizlin/fe-interview/issues/720)
- [React的性能优化在哪个生命周期？它优化的原理是什么？](https://github.com/haizlin/fe-interview/issues/719)
- [你知道的React性能优化有哪些方法？](https://github.com/haizlin/fe-interview/issues/718)
- [举例说明在React中怎么使用样式？](https://github.com/haizlin/fe-interview/issues/717)
- [React有哪几种方法来处理表单输入？](https://github.com/haizlin/fe-interview/issues/716)
- [什么是浅层渲染？](https://github.com/haizlin/fe-interview/issues/715)
- [你有做过React的单元测试吗？如果有，用的是哪些工具？怎么做的？](https://github.com/haizlin/fe-interview/issues/714)
- [在React中什么是合成事件？有什么用？](https://github.com/haizlin/fe-interview/issues/713)
- [使用React写一个todo应用，说说你的思路](https://github.com/haizlin/fe-interview/issues/712)
- [React16的reconciliation和commit分别是什么？](https://github.com/haizlin/fe-interview/issues/711)
- [React的函数式组件有没有生命周期？](https://github.com/haizlin/fe-interview/issues/710)
- [useState和this.state的区别是什么？](https://github.com/haizlin/fe-interview/issues/709)
- [请说说什么是useImperativeHandle？](https://github.com/haizlin/fe-interview/issues/708)
- [请说说什么是useReducer？](https://github.com/haizlin/fe-interview/issues/707)
- [请说说什么是useRef？](https://github.com/haizlin/fe-interview/issues/706)
- [请说说什么是useEffect？](https://github.com/haizlin/fe-interview/issues/705)
- [举例说明useState](https://github.com/haizlin/fe-interview/issues/704)
- [请说说什么是useState？为什么要使用useState？](https://github.com/haizlin/fe-interview/issues/703)
- [请描述下你对React的新特性Hooks的理解？它有哪些应用场景？](https://github.com/haizlin/fe-interview/issues/702)
- [说说你对Error Boundaries的理解](https://github.com/haizlin/fe-interview/issues/701)
- [说说你对Fiber架构的理解](https://github.com/haizlin/fe-interview/issues/700)
- [说说你是怎么理解React的业务组件和技术组件的？](https://github.com/haizlin/fe-interview/issues/699)
- [为什么建议setState的第一个参数是callback而不是一个对象呢？](https://github.com/haizlin/fe-interview/issues/698)
- [展示组件和容器组件有什么区别？](https://github.com/haizlin/fe-interview/issues/697)
- [Mern和Yeoman脚手架有什么区别？](https://github.com/haizlin/fe-interview/issues/696)
- [你有在项目中使用过Yeoman脚手架吗？](https://github.com/haizlin/fe-interview/issues/695)
- [你有在项目中使用过Mern脚手架吗？](https://github.com/haizlin/fe-interview/issues/694)
- [shouldComponentUpdate方法是做什么的？](https://github.com/haizlin/fe-interview/issues/693)
- [怎样在React中使用innerHTML？](https://github.com/haizlin/fe-interview/issues/692)
- [你有写过React的中间件插件吗？](https://github.com/haizlin/fe-interview/issues/691)
- [React的中间件机制是怎么样的？这种机制有什么作用？](https://github.com/haizlin/fe-interview/issues/690)
- [React中你用过哪些第三方的中间件？](https://github.com/haizlin/fe-interview/issues/689)
- [不用脚手架，你会手动搭建React项目吗？](https://github.com/haizlin/fe-interview/issues/688)
- [请说说React中Portal是什么？](https://github.com/haizlin/fe-interview/issues/687)
- [React中修改prop引发的生命周期有哪几个？](https://github.com/haizlin/fe-interview/issues/686)
- [React多个setState调用的原理是什么？](https://github.com/haizlin/fe-interview/issues/685)
- [React中调用setState会更新的生命周期有哪几个？](https://github.com/haizlin/fe-interview/issues/684)
- [React中setState的第二个参数作用是什么呢？](https://github.com/haizlin/fe-interview/issues/683)
- [React中的setState是同步还是异步的呢？为什么state并不一定会同步更新？](https://github.com/haizlin/fe-interview/issues/682)
- [React中的setState批量更新的过程是什么？](https://github.com/haizlin/fe-interview/issues/681)
- [React中的setState执行机制是什么呢？](https://github.com/haizlin/fe-interview/issues/680)
- [在React中遍历的方法有哪些？它们有什么区别呢？](https://github.com/haizlin/fe-interview/issues/679)
- [请说说你对React的render方法的理解](https://github.com/haizlin/fe-interview/issues/678)
- [props.children.map和js的map有什么区别？为什么优先选择React的？](https://github.com/haizlin/fe-interview/issues/677)
- [有用过React的严格模式吗？](https://github.com/haizlin/fe-interview/issues/676)
- [React中的setState和replaceState的区别是什么？](https://github.com/haizlin/fe-interview/issues/675)
- [React中的setState缺点是什么呢？](https://github.com/haizlin/fe-interview/issues/674)
- [有用过React的Fragment吗？它的运用场景是什么？](https://github.com/haizlin/fe-interview/issues/673)
- [React组件间共享数据方法有哪些？](https://github.com/haizlin/fe-interview/issues/672)
- [React的状态提升是什么？使用场景有哪些？](https://github.com/haizlin/fe-interview/issues/671)
- [简单描述下你有做过哪些React项目？](https://github.com/haizlin/fe-interview/issues/670)
- [在构造函数中调用super(props)的目的是什么？](https://github.com/haizlin/fe-interview/issues/669)
- [你是如何学习React的？](https://github.com/haizlin/fe-interview/issues/668)
- [从旧版本的React升级到新版本的React有做过吗？有遇到过什么坑？](https://github.com/haizlin/fe-interview/issues/667)
- [你用过React版本有哪些？](https://github.com/haizlin/fe-interview/issues/666)
- [有用过React的服务端渲染吗？怎么做的？](https://github.com/haizlin/fe-interview/issues/665)
- [React的mixins有什么作用？适用于什么场景？](https://github.com/haizlin/fe-interview/issues/664)
- [React怎么拿到组件对应的DOM元素？](https://github.com/haizlin/fe-interview/issues/663)
- [请描述下事件在React中的处理方式是什么？](https://github.com/haizlin/fe-interview/issues/662)
- [JSX和HTML有什么区别？](https://github.com/haizlin/fe-interview/issues/661)
- [React的书写规范有哪些？](https://github.com/haizlin/fe-interview/issues/660)
- [create-react-app创建新运用怎么解决卡的问题？](https://github.com/haizlin/fe-interview/issues/659)
- [使用React的方式有哪几种？](https://github.com/haizlin/fe-interview/issues/658)
- [说说你对reader的context的理解](https://github.com/haizlin/fe-interview/issues/657)
- [同时引用这三个库React.js、React-dom.js和babel.js它们都有什么作用？](https://github.com/haizlin/fe-interview/issues/656)
- [你知道Virtual DOM的工作原理吗？](https://github.com/haizlin/fe-interview/issues/655)
- [你阅读过React的源码吗？简要说下它的执行流程](https://github.com/haizlin/fe-interview/issues/654)
- [React中怎样阻止组件渲染？](https://github.com/haizlin/fe-interview/issues/653)
- [React非兄弟组件如何通信？](https://github.com/haizlin/fe-interview/issues/652)
- [React兄弟组件如何通信？](https://github.com/haizlin/fe-interview/issues/651)
- [React非父子组件如何通信？](https://github.com/haizlin/fe-interview/issues/650)
- [React父子组件如何通信？](https://github.com/haizlin/fe-interview/issues/649)
- [React组件间的通信有哪些？](https://github.com/haizlin/fe-interview/issues/648)
- [类组件和函数式组件有什么区别？](https://github.com/haizlin/fe-interview/issues/647)
- [React自定义组件你写过吗？说说看都写过哪些？](https://github.com/haizlin/fe-interview/issues/646)
- [React组件的state和props两者有什么区别？](https://github.com/haizlin/fe-interview/issues/645)
- [React有几种构建组件的方式？可以写出来吗？](https://github.com/haizlin/fe-interview/issues/644)
- [React中遍历时为什么不用索引作为唯一的key值？](https://github.com/haizlin/fe-interview/issues/643)
- [React中的key有什么作用？](https://github.com/haizlin/fe-interview/issues/642)
- [React中除了在构造函数中绑定this,还有别的方式吗？](https://github.com/haizlin/fe-interview/issues/641)
- [在React中页面重新加载时怎样保留数据？](https://github.com/haizlin/fe-interview/issues/640)
- [请描述下React的事件机制](https://github.com/haizlin/fe-interview/issues/639)
- [怎样在React中创建一个事件？](https://github.com/haizlin/fe-interview/issues/638)
- [在React中无状态组件有什么运用场景？](https://github.com/haizlin/fe-interview/issues/637)
- [描述下在React中无状态组件和有状态组件的区别是什么？](https://github.com/haizlin/fe-interview/issues/636)
- [写一个React的高阶组件(HOC)并说明你对它的理解](https://github.com/haizlin/fe-interview/issues/635)
- [React中可以在render访问refs吗？为什么？](https://github.com/haizlin/fe-interview/issues/634)
- [React中refs的作用是什么？有哪些应用场景？](https://github.com/haizlin/fe-interview/issues/633)
- [请描述你对纯函数的理解？](https://github.com/haizlin/fe-interview/issues/632)
- [受控组件和非受控组件有什么区别？](https://github.com/haizlin/fe-interview/issues/631)
- [React中什么是非控组件？](https://github.com/haizlin/fe-interview/issues/630)
- [React中什么是受控组件？](https://github.com/haizlin/fe-interview/issues/629)
- [React中发起网络请求应该在哪个生命周期中进行？为什么？](https://github.com/haizlin/fe-interview/issues/628)
- [说说React的生命周期有哪些？](https://github.com/haizlin/fe-interview/issues/627)
- [说说你对“在React中，一切都是组件”的理解](https://github.com/haizlin/fe-interview/issues/626)
- [写React你是用es6还是es5的语法？有什么区别？](https://github.com/haizlin/fe-interview/issues/625)
- [浏览器为什么无法直接JSX？怎么解决呢？](https://github.com/haizlin/fe-interview/issues/624)
- [在使用React过程中你都踩过哪些坑？你是怎么填坑的？](https://github.com/haizlin/fe-interview/issues/623)
- [说说你喜欢React的原因是什么？它有什么优缺点？](https://github.com/haizlin/fe-interview/issues/622)
- [如何解决引用类型在pureComponent下修改值的时候，页面不渲染的问题？](https://github.com/haizlin/fe-interview/issues/621)
- [createElement与cloneElement两者有什么区别？](https://github.com/haizlin/fe-interview/issues/620)
- [解释下React中Element 和Component两者的区别是什么？](https://github.com/haizlin/fe-interview/issues/619)
- [解释下React中component和pureComponent两者的区别是什么？](https://github.com/haizlin/fe-interview/issues/618)
- [React的虚拟DOM和vue的虚拟DOM有什么区别？](https://github.com/haizlin/fe-interview/issues/617)
- [你觉得React上手快不快？它有哪些限制？](https://github.com/haizlin/fe-interview/issues/616)
- [说说你对声明式编程的理解？](https://github.com/haizlin/fe-interview/issues/615)
- [React与angular、vue有什么区别？](https://github.com/haizlin/fe-interview/issues/614)
- [React是哪个公司开发的？](https://github.com/haizlin/fe-interview/issues/613)
- [React是什么？它的主要特点是什么？](https://github.com/haizlin/fe-interview/issues/612)
- [简要描述下你知道的React工作原理是什么？](https://github.com/haizlin/fe-interview/issues/611)
- [在React中怎样改变组件状态，以及状态改变的过程是什么？](https://github.com/haizlin/fe-interview/issues/606)
- [在React中你是怎么进行状态管理的？](https://github.com/haizlin/fe-interview/issues/605)
- [React声明组件有哪几种方法，各有什么不同？](https://github.com/haizlin/fe-interview/issues/604)

### ReactNative
- [如何在React Native中设置环境变量？]()
- [请描述下Code Push的原理是什么？](https://github.com/haizlin/fe-interview/issues/783)
- [React Native怎样查看日记？](https://github.com/haizlin/fe-interview/issues/782)
- [React Native怎样测试？](https://github.com/haizlin/fe-interview/issues/781)
- [React Native怎样调试？](https://github.com/haizlin/fe-interview/issues/780)
- [React Native和React有什么区别？](https://github.com/haizlin/fe-interview/issues/779)
- [有做过React Native项目吗？](https://github.com/haizlin/fe-interview/issues/725)

### React-Router
- [React-Router怎么获取历史对象？](https://github.com/haizlin/fe-interview/issues/922)
- [React-Router怎么获取URL的参数？](https://github.com/haizlin/fe-interview/issues/921)
- [在history模式中push和replace有什么区别？](https://github.com/haizlin/fe-interview/issues/778)
- [React-Router怎么设置重定向？](https://github.com/haizlin/fe-interview/issues/777)
- [React-Router 4中`<Router>`组件有几种类型？](https://github.com/haizlin/fe-interview/issues/776)
- [React-Router 3和React-Router 4有什么变化？添加了什么好的特性？](https://github.com/haizlin/fe-interview/issues/775)
- [React-Router的实现原理是什么？](https://github.com/haizlin/fe-interview/issues/774)
- [React-Router 4的switch有什么用？](https://github.com/haizlin/fe-interview/issues/773)
- [React-Router的路由有几种模式？](https://github.com/haizlin/fe-interview/issues/772)
- [React-Router 4怎样在路由变化时重新渲染同一个组件？](https://github.com/haizlin/fe-interview/issues/771)
- [React-Router的`<Link>`标签和`<a>`标签有什么区别？](https://github.com/haizlin/fe-interview/issues/770)
- [React的路由和普通路由有什么区别？](https://github.com/haizlin/fe-interview/issues/728)
- [请你说说React的路由的优缺点？](https://github.com/haizlin/fe-interview/issues/727)
- [请你说说React的路由是什么？](https://github.com/haizlin/fe-interview/issues/726)

### Redux/Mobx
- [你有了解Rxjs是什么吗？它是做什么的？](https://github.com/haizlin/fe-interview/issues/920)
- [在Redux中怎么发起网络请求？](https://github.com/haizlin/fe-interview/issues/919)
- [Redux怎样重置状态？](https://github.com/haizlin/fe-interview/issues/918)
- [Redux怎样设置初始状态？](https://github.com/haizlin/fe-interview/issues/917)
- [Context api可以取代Redux吗？为什么？](https://github.com/haizlin/fe-interview/issues/916)
- [推荐在reducer中触发Action吗？为什么？](https://github.com/haizlin/fe-interview/issues/915)
- [Redux怎么添加新的中间件？](https://github.com/haizlin/fe-interview/issues/914)
- [redux-saga和redux-thunk有什么本质的区别？](https://github.com/haizlin/fe-interview/issues/913)
- [在React中你是怎么对异步方案进行选型的？](https://github.com/haizlin/fe-interview/issues/912)
- [你知道redux-saga的原理吗？](https://github.com/haizlin/fe-interview/issues/911)
- [你有使用过redux-saga中间件吗？它是干什么的？](https://github.com/haizlin/fe-interview/issues/910)
- [Redux中异步action和同步action最大的区别是什么？](https://github.com/haizlin/fe-interview/issues/769)
- [Redux和vuex有什么区别？](https://github.com/haizlin/fe-interview/issues/768)
- [Redux的中间件是什么？你有用过哪些Redux的中间件？](https://github.com/haizlin/fe-interview/issues/767)
- [说说Redux的实现流程](https://github.com/haizlin/fe-interview/issues/766)
- [Mobx的设计思想是什么？](https://github.com/haizlin/fe-interview/issues/765)
- [Redux由哪些组件构成？](https://github.com/haizlin/fe-interview/issues/764)
- [Mobx和Redux有什么区别？](https://github.com/haizlin/fe-interview/issues/763)
- [在React项目中你是如何选择Redux和Mobx的？说说你的理解](https://github.com/haizlin/fe-interview/issues/762)
- [你有在React中使用过Mobx吗？它的运用场景有哪些？](https://github.com/haizlin/fe-interview/issues/761)
- [Redux的thunk作用是什么？](https://github.com/haizlin/fe-interview/issues/740)
- [Redux的数据存储和本地储存有什么区别？](https://github.com/haizlin/fe-interview/issues/739)
- [在Redux中，什么是reducer？它有什么作用？](https://github.com/haizlin/fe-interview/issues/738)
- [举例说明怎么在Redux中定义action？](https://github.com/haizlin/fe-interview/issues/737)
- [在Redux中，什么是action？](https://github.com/haizlin/fe-interview/issues/736)
- [在Redux中，什么是store？](https://github.com/haizlin/fe-interview/issues/735)
- [为什么Redux能做到局部渲染呢？](https://github.com/haizlin/fe-interview/issues/734)
- [说说Redux的优缺点分别是什么？](https://github.com/haizlin/fe-interview/issues/733)
- [Redux和Flux的区别是什么？](https://github.com/haizlin/fe-interview/issues/732)
- [Redux它的三个原则是什么？](https://github.com/haizlin/fe-interview/issues/731)
- [什么是单一数据源？](https://github.com/haizlin/fe-interview/issues/730)
- [什么是Redux？说说你对Redux的理解？有哪些运用场景？](https://github.com/haizlin/fe-interview/issues/729)

### Flux
- [请说说点击按钮触发到状态更改，数据的流向？](https://github.com/haizlin/fe-interview/issues/742)
- [请描述下Flux的思想](https://github.com/haizlin/fe-interview/issues/742)
- [什么是Flux？说说你对Flux的理解？有哪些运用场景？](https://github.com/haizlin/fe-interview/issues/741)
